<template>
  <div
    @click="$emit('click')"
    class="like-button"
    :style="selected? backgroundRules: '' "
  >
    <svg ref="circle" :class="{dislike: !positive}" :style="colorRules">
      <g :transform="svgTransform" id="g847">
        <path
          class="st2"
          d="m 140.2,371 h 30.4 c 11.8,0 21.3,-9.6 21.3,-21.3 v -140 c 0,-11.8 -9.6,-21.3 -21.3,-21.3 h -30.4 c -11.8,0 -21.3,9.6 -21.3,21.3 v 140 c 0,11.7 9.5,21.3 21.3,21.3 z"
          id="path843"
        />
        <path
          class="st2"
          d="m 274.5,100 c -12.2,0 -18.3,6.1 -18.3,36.5 0,28.9 -28,52.2 -46,64.2 v 150.9 c 19.5,9 58.5,22.4 119.1,22.4 h 19.5 c 23.7,0 44,-17 48,-40.4 l 13.6,-79.2 c 5.1,-29.8 -17.8,-57 -48,-57 H 305 c 0,0 9.1,-18.3 9.1,-48.7 0,-36.5 -27.4,-48.7 -39.6,-48.7 z"
          id="path845"
        />
      </g>
    </svg>
  </div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator";
@Component
export default class LikeButton extends Vue {
  @Prop({ default: true }) readonly positive!: boolean;
  @Prop({ default: false }) readonly selected!: boolean;

  backgroundColor = "#feca38";
  textColor = "#000";
  svgTransform = "";
  get backgroundRules() {
    return `background-color: ${this.backgroundColor};`;
  }

  get colorRules() {
    if (this.selected) {
      return `fill:${this.textColor}`;
    }

    return "fill:#B3B6B8";
  }

  created() {
    const colors = this.$store.getters.colors;
    this.backgroundColor = colors.backgroundColor;
    this.textColor = colors.textColor;
  }
  
  mounted() {
    const circle = this.$refs.circle as Element;
    const originalHeight = 274 
    // const originalWidth = 292 
    const scale = (circle.clientHeight* 0.75) / (originalHeight)
    const x = -(circle.clientWidth/2) * .50
    const y = -(circle.clientHeight/2) * .40
    this.svgTransform = `translate(${x},${y}) scale(${scale})`;
  }
}
</script>

<style lang="scss" scoped>
.like-button {
  background-color: #f1f5f8;
  width: 20px;
  height: 20px;
  border-radius: 50%;
  padding: 5px;
  display: flex;


  svg {
    margin: auto;
    width: 110%;
    height: 110%;
  }

  .dislike {
    transform: rotate(180deg);
  }
}
</style>
